"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dotenv_1 = __importDefault(require("dotenv"));
const path_1 = __importDefault(require("path"));
const request_promise_native_1 = __importDefault(require("request-promise-native"));
const Rest_1 = __importDefault(require("./Rest"));
const Limiter_1 = __importDefault(require("./utils/Limiter"));
dotenv_1.default.config({ path: path_1.default.resolve(process.cwd(), process.env.BOT_NAME ? `.env.${process.env.BOT_NAME}` : '.env') });
const toInt = (s) => Number.parseInt(s, undefined);
exports.rest = new Rest_1.default(request_promise_native_1.default.defaults({
    auth: {
        bearer: process.env.TOKEN
    },
    baseUrl: `https://${process.env.DOMAIN}/api/v1/`,
    timeout: toInt(process.env.TIMEOUT),
    json: true
}), new Limiter_1.default(toInt(process.env.LIMIT_COUNT), toInt(process.env.LIMIT_TIME)));
exports.rootStatus = process.env.ROOT_STATUS;
