"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prepare_1 = require("../../prepare");
const Logger_1 = __importDefault(require("../../utils/Logger"));
function run() {
    return __awaiter(this, void 0, void 0, function* () {
        const [, , content, visibility] = process.argv;
        if (!content) {
            Logger_1.default.error('require content');
            return;
        }
        Logger_1.default.info(`adding action: "${content}"`);
        const status = yield prepare_1.rest.postStatus({
            in_reply_to_id: prepare_1.rootStatus,
            status: content,
            visibility: visibility || 'direct'
        });
        Logger_1.default.info('action added', { id: status.id, tags: status.tags.map(t => t.name).reverse() });
    });
}
run();
