"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const prepare_1 = require("../../prepare");
const Logger_1 = __importDefault(require("../../utils/Logger"));
function run() {
    return __awaiter(this, void 0, void 0, function* () {
        const [, , file, title, visibility] = process.argv;
        if (!file) {
            Logger_1.default.error('require file');
            return;
        }
        const post = (inReplyToId, status) => __awaiter(this, void 0, void 0, function* () {
            return prepare_1.rest.postStatus({
                in_reply_to_id: inReplyToId,
                status,
                visibility: visibility || 'direct'
            }).then(s => s.id);
        });
        // TODO: push database.json
        const data = JSON.parse(fs_1.default.readFileSync(file, 'utf8'));
        const folder = yield post(prepare_1.rootStatus, title || file);
        Logger_1.default.info('Content length', data.length);
        for (const row of data) {
            if (typeof row === 'string') {
                yield post(folder, row);
            }
            else if (typeof row === 'object') {
                const content = '\n' + Object.entries(row).map(([lang, message]) => `[${lang}] ${message}`).join('\n\n');
                const global = yield post(folder, content);
                for (const [lang, message] of Object.entries(row)) {
                    yield post(global, `${message} #${lang}`);
                }
            }
            else {
                throw new Error('bad type ' + typeof row);
            }
        }
        Logger_1.default.info('Data added', folder);
    });
}
run();
