"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const querystring_1 = __importDefault(require("querystring"));
const readline_1 = __importDefault(require("readline"));
const request_promise_native_1 = __importDefault(require("request-promise-native"));
const prepare_1 = require("../../prepare");
const Logger_1 = __importDefault(require("../../utils/Logger"));
function run() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            Logger_1.default.info('Checking current token');
            const { acct: me } = yield prepare_1.rest.getMe();
            Logger_1.default.info(`Already logged as ${me}`);
        }
        catch (error) {
            Logger_1.default.info('Trying to get token');
            const redirectUri = 'urn:ietf:wg:oauth:2.0:oob';
            const scopes = 'read:accounts read:statuses write:statuses write:media';
            const { client_id, client_secret } = yield prepare_1.rest.postApp(redirectUri, scopes);
            const rl = readline_1.default.createInterface({
                input: process.stdin,
                output: process.stdout
            });
            Logger_1.default.info(`Please visit: https://${process.env.DOMAIN}/oauth/authorize?scope=${querystring_1.default.escape(scopes)}&redirect_uri=${redirectUri}&response_type=code&client_id=${client_id} to validate your token`);
            rl.question('And then paste token here: ', (code) => __awaiter(this, void 0, void 0, function* () {
                const { access_token } = yield request_promise_native_1.default.post(`https://${process.env.DOMAIN}/oauth/token`, {
                    json: true,
                    body: {
                        client_id, client_secret,
                        grant_type: 'authorization_code',
                        code, redirect_uri: redirectUri
                    }
                });
                rl.write(`Put TOKEN=${access_token} in .env`);
                rl.close();
            }));
        }
    });
}
run();
