"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const winston_1 = require("winston");
const { colorize, combine, simple, prettyPrint } = winston_1.format;
const { Console } = winston_1.transports;
const isProd = process.env.NODE_ENV === 'production';
const Logger = winston_1.createLogger({
    format: combine(colorize(), simple()),
    transports: [new Console({ level: isProd ? 'warn' : 'debug' })]
});
if (!isProd) {
    Logger.debug('Logging initialized at debug level');
}
exports.default = Logger;
