"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function match(params, tag) {
    for (const key in params) {
        if (params.hasOwnProperty(key)) {
            const value = params[key];
            if (value === false && key === tag) { // Activator
                params[key] = true;
            }
            if (tag.startsWith(`${key}_`)) {
                const subTag = tag.substr(key.length + 1);
                if (Array.isArray(value)) {
                    params[key].push(subTag);
                }
                else {
                    switch (typeof value) {
                        case 'string':
                            params[key] = subTag;
                            break;
                        case 'number':
                            params[key] = Number(subTag);
                            break;
                        case 'object':
                            params[key] = match(params[key], subTag);
                            break;
                        default:
                            throw new Error('Bad type');
                    }
                }
            }
        }
    }
    return params;
}
exports.match = match;
/** Unsafe recursive matcher */
function matcher(params, tags) {
    for (const tag of tags) {
        params = match(params, tag);
    }
    return params;
}
exports.default = matcher;
